import { jsx as _jsx } from "react/jsx-runtime";
import './index.less';

var ProCardActions = function ProCardActions(props) {
  var actions = props.actions,
      prefixCls = props.prefixCls;

  if (Array.isArray(actions) && (actions === null || actions === void 0 ? void 0 : actions.length)) {
    return _jsx("ul", {
      className: "".concat(prefixCls, "-actions"),
      children: actions.map(function (action, index) {
        return (// eslint-disable-next-line react/no-array-index-key
          _jsx("li", {
            style: {
              width: "".concat(100 / actions.length, "%")
            },
            children: _jsx("span", {
              children: action
            })
          }, "action-".concat(index))
        );
      })
    });
  }

  if (actions) return _jsx("ul", {
    className: "".concat(prefixCls, "-actions"),
    children: actions
  });
  return null;
};

export default ProCardActions;