import type { BadgeProps } from 'antd/lib/badge';
import type { StatisticProps as AntdStatisticProps } from 'antd/lib/statistic/Statistic';
import React from 'react';
import './index.less';
export interface StatisticProps extends AntdStatisticProps {
    /**
     * 样式
     *
     * @ignore
     */
    style?: React.CSSProperties;
    /**
     * ClassName
     *
     * @ignore
     */
    className?: string;
    /** 描述性标签 */
    description?: React.ReactNode;
    /** 标题提示 */
    tip?: React.ReactNode;
    /** 当前项显示的状态 */
    status?: BadgeProps['status'] | undefined;
    /** Icon 图标 */
    icon?: React.ReactNode;
    /** Layout 布局 */
    layout?: 'horizontal' | 'vertical' | 'inline';
    /** 趋势 */
    trend?: 'up' | 'down';
    children?: any;
}
declare const Statistic: React.FC<StatisticProps>;
export default Statistic;
