"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.useLegacyItems = useLegacyItems;

require("antd/lib/tabs/style");

var _tabs = _interopRequireDefault(require("antd/lib/tabs"));

require("antd/lib/config-provider/style");

var _configProvider = _interopRequireDefault(require("antd/lib/config-provider"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _jsxRuntime = require("react/jsx-runtime");

var _classnames = _interopRequireDefault(require("classnames"));

var _toArray = _interopRequireDefault(require("rc-util/lib/Children/toArray"));

var _warning = require("rc-util/lib/warning");

var _react = _interopRequireWildcard(require("react"));

var _Card = _interopRequireDefault(require("../Card"));

require("./index.less");

var _excluded = ["tab", "children"],
    _excluded2 = ["key", "tab", "tabKey", "disabled", "destroyInactiveTabPane", "children", "className", "style", "cardProps"];

function filter(items) {
  return items.filter(function (item) {
    return item;
  });
}

function useLegacyItems(items, children, tabs) {
  if (items) {
    return items.map(function (item) {
      return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, item), {}, {
        children: (0, _jsxRuntime.jsx)(_Card.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, tabs === null || tabs === void 0 ? void 0 : tabs.cardProps), {}, {
          children: item.children
        }))
      });
    });
  }

  (0, _warning.noteOnce)(!tabs, 'Tabs.TabPane is deprecated. Please use `items` directly.');
  var childrenItems = (0, _toArray.default)(children).map(function (node) {
    if ( /*#__PURE__*/_react.default.isValidElement(node)) {
      var key = node.key,
          props = node.props;

      var _ref = props || {},
          tab = _ref.tab,
          tempChild = _ref.children,
          restProps = (0, _objectWithoutProperties2.default)(_ref, _excluded);

      var item = (0, _objectSpread2.default)((0, _objectSpread2.default)({
        key: String(key)
      }, restProps), {}, {
        children: (0, _jsxRuntime.jsx)(_Card.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, tabs === null || tabs === void 0 ? void 0 : tabs.cardProps), {}, {
          children: tempChild
        })),
        label: tab
      });
      return item;
    }

    return null;
  });
  return filter(childrenItems);
}

var TabPane = function TabPane(props) {
  var key = props.key,
      tab = props.tab,
      tabKey = props.tabKey,
      disabled = props.disabled,
      destroyInactiveTabPane = props.destroyInactiveTabPane,
      children = props.children,
      className = props.className,
      style = props.style,
      cardProps = props.cardProps,
      rest = (0, _objectWithoutProperties2.default)(props, _excluded2);

  var _useContext = (0, _react.useContext)(_configProvider.default.ConfigContext),
      getPrefixCls = _useContext.getPrefixCls;

  var prefixCls = getPrefixCls('pro-card-tabpane');
  var tabPaneClassName = (0, _classnames.default)(prefixCls, className);
  return (0, _jsxRuntime.jsx)(_tabs.default.TabPane, (0, _objectSpread2.default)((0, _objectSpread2.default)({
    tabKey: tabKey,
    tab: tab,
    className: tabPaneClassName,
    style: style,
    disabled: disabled,
    destroyInactiveTabPane: destroyInactiveTabPane
  }, rest), {}, {
    children: (0, _jsxRuntime.jsx)(_Card.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, cardProps), {}, {
      children: children
    }))
  }), key);
};

var _default = TabPane;
exports.default = _default;